#include <unistd.h>
#include <stdio.h>
#include <stdlib.h>
#include <fcntl.h>
#include <linux/lp.h>
#include <linux/fs.h>
#include <sys/ioctl.h>
#include <sys/stat.h>
#include <sys/types.h>
#include <malloc.h>
#include <string.h>
#include <errno.h>
#include <time.h>
#include <signal.h>
#include <sys/time.h>
#include <dirent.h>

/*
 * Version info
 */
#define VERSION 0
#define SUB_VERSION 9
#define REVISION 2

#define STDPORT "/dev/lp1"

/*
 *	debug strange time-difference behaviour
 */
/*#define STD_DBG*/

/*
 *  number of seconds, for which time differences can be adjusted smoothly
 */
#define MAXSMOOTHADJUST 20


/*
 * 	maximum number of lp ports
 */
#define MAXLPPORTS 4

#define BASENAME(x) (strrchr(x,'/') != NULL ? strrchr(x,'/') + 1 : x)
#define NUMBYTES 9

#define TRUE 1
#define FALSE 0

#define ABS(x) ((x) < 0 ? -(x) : (x))

/*
 *	Command words to the PC-Funkuhr
 */
#define GETPCF77TIME 0
#define CHECKQUALITY 7
#define CONTQUALCHEK 9

/*
 *	PC-Funkuhr just transmits two digits representing the year.
 *	So one must decide which century is the actual one.
 *	The following define says until which two-digit-year the 20th century
 *	is choosen.
 */
#define CENTURYYEAR 90


/*
 *	# of trials to talk to DCF clock
 */
#define TRIALS 3

/*
 *	time constants in usec for evaluating signal strength of DCF radio signal
 */
#define DCF_SIGNAL_WAIT 12000L
#define DCF_BITLEN0 100000L
#define DCF_BITLEN1 200000L

/*
 *	E-Mail Address of the author
 */
#define MYEMAIL matthias@familie-schuetze.de

/*
 *	length of long strings
 */
#define LSTRLEN 127

/*
 *	length of short strings
 */
#define SSTRLEN 63

/*
 * initial template string for strftime
 */
char pbTEMPL[LSTRLEN + 1] = "today is %A, %d.%m.%Y; time is %H:%M:%S %Z";

/*
 *	function prototypes
 */
void usage(void);
int  timeval_subtract(struct timeval *result,\
					  struct timeval *x,struct timeval *y);
int  adjust_seconds(struct tm *bt,struct timeval *TP,int *msec);
void signal_handler(int sig);
void init_sighandler(void);
void quality_out(int handle);
int  sendwarning(char *warning);
int  talktoclock(char *portname,int witherrors);
int  talktoalldevices(void);
int  main(int argc, char **argv);








