#!/bin/sh

TARGET=$1
KERNEL=`uname -r`

#############################################################################
#
FILES="$TARGET.1 $TARGET.lsm LIESMICH README"

VERSIONKEEPER=$TARGET.h

VERSION=`grep -w VERSION $VERSIONKEEPER | cut -f 3 -d ' '`
SUB_VERSION=`grep -w SUB_VERSION $VERSIONKEEPER | cut -f 3 -d ' '`
REVISION=`grep -w REVISION $VERSIONKEEPER | cut -f 3 -d ' '`
STDPORT=`grep -w STDPORT $VERSIONKEEPER | cut -f 3 -d ' ' | sed 's/\"//g'`
MAXSMOOTHADJUST=`grep -w MAXSMOOTHADJUST $VERSIONKEEPER | cut -f 3 -d ' '`
CENTURYYEAR=`grep -w CENTURYYEAR $VERSIONKEEPER | cut -f 3 -d ' '`
MYEMAIL=`grep -w MYEMAIL $VERSIONKEEPER | cut -f 3 -d ' '`
DATE=`date +"%d %b %y"`
LSMDATE=`echo $DATE | sed 's/ //g' | tr '[:lower:]' '[:upper:]'`

sed "s?@@DATE@@?$LSMDATE?g" $TARGET.lsm.in >$TARGET.lsmtmp
mv $TARGET.lsmtmp $TARGET.lsm.in

if [ "X$2" = "X-a" ]; then
# if parameter -a is given:
    for i in $FILES; do
	if [ -e $i.in ]; then
	    sed "s?@@KERNEL@@?$KERNEL?g" $i.in | \
	    sed "s?@@TARGET@@?$TARGET?g" | sed "s?@@DATE@@?$DATE?g" | \
	    sed "s?@@STDPORT@@?$STDPORT?g" | \
	    sed "s?@@MYEMAIL@@?$MYEMAIL?g" | \
	    sed "s?@@CENTURYYEAR@@?$CENTURYYEAR?g" | \
	    sed "s?@@MAXSMOOTHADJUST@@?$MAXSMOOTHADJUST?g" | \
	    sed "s?@@VERSION@@?$VERSION.$SUB_VERSION.$REVISION?g" >$i
	fi
    done
fi

# @@USAGE@@ must be evaluated separately for the following files
for i in LIESMICH README; do
    if [ ! `grep @@USAGE@@ $i` ]; then
	continue
    fi
    LINE=`grep -n @@USAGE@@ $i | awk -F: '{print $1}'`
    LINE=`expr $LINE - 1`
    LINES=`wc -l $i | awk '{print $1}'`
    cp $i $i.tmp
    head -$LINE $i.tmp >$i
    $TARGET -h 2>>$i
    LINES=`expr $LINES - 1 - $LINE`
    tail -$LINES $i.tmp >>$i
    rm $i.tmp
done

echo $VERSION.$SUB_VERSION.$REVISION
exit 0








